package oracle.forms.fd;

import java.awt.Dimension;
import java.awt.Graphics;

import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.List;

import java.util.StringTokenizer;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

import oracle.forms.handler.IHandler;
import oracle.forms.ui.VTextField;
import oracle.forms.properties.ID;

    /**
     * A PJC to include a menu in a TextField
     * 
     * @author   Francois Degrelle
     * creation  november 2009
     */



public class ComboMenuPJC extends VTextField  {
    
    public final static ID setMenu          = ID.registerProperty("SET_MENU");
    public final static ID setBorder        = ID.registerProperty("SET_BORDER");            
    public final static ID setLog           = ID.registerProperty("SET_LOG");            
    
    boolean bFirst         = true ;
    boolean bLog           = false ;
    ComboMenuBar comboMenu = new ComboMenuBar(); 
    JMenu menu             = null ;   
    String sXMLMenu        = null ;
    public String  sValue  = null ;
    String         sBorder = "line" ;
    
    public void init(IHandler handler)
    {
      super.init(handler);
    }      
    
    public ComboMenuPJC() {
        super();
    }
    
    public void paint(Graphics g){
       if(bFirst)        {         
           comboMenu.setPJC(this);
           comboMenu.setBounds(this.getBounds());
           comboMenu.setComboSize(this.getWidth(), this.getHeight());
           comboMenu.setBackground(this.getBackground());
           comboMenu.setForeground(this.getForeground());
           comboMenu.setFont(this.getFont());
           comboMenu.setValue(sValue);
           comboMenu.setMenuBorder(sBorder);
           if(menu == null) { 
             menu = ComboMenuBar.createMenu(" "); 
             comboMenu.setMenu(menu);
           }
           this.getParent().add(comboMenu);        
           comboMenu.repaint();
           this.setSize(1,1);
           bFirst = false ;
       }
       super.paint(g);
    }
    
    
    /*-----------------------------------*
     *  populate initial Text Item with  *
     *  selected menu value              *
     *-----------------------------------*/
    public void setValue( String sText ){
        this.setProperty(ID.VALUE, sText);
        this.requestFocus();
        System.out.println("setValue():"+getProperty(ID.VALUE));
    }
    
  public boolean setProperty(ID property, Object value)
  {
  
    log(property+":"+value);
    
    if(property == setMenu){
        sXMLMenu = (String)value ;
        sXMLMenu =  sXMLMenu.replaceAll("[\\r\\n]", "|");
        String sLabel = getXMLTag(sXMLMenu, "label", "Start");
        menu = ComboMenuBar.createMenu(sLabel); 
        readXMLMenu("menu");          
        comboMenu.setMenu(menu);
        comboMenu.repaint();

        return true ;
    }

    else if(property == setBorder){
      sBorder = (String)value ;
      if(comboMenu != null) comboMenu.setMenuBorder(sBorder);
      return true;
    }
    
    else if(property == ID.VALUE){
      sValue = (String)value ;
      return super.setProperty(property, value);
    }
    
    else if(property == setLog){
      String s = (String)value ;
      if(s.equalsIgnoreCase("true")) bLog = true ;
      else if(s.equalsIgnoreCase("false")) bLog = false ;
      return true ;
    }

    else return super.setProperty(property, value);
    
  } 
  

    /**------------------------------------------*
     *   returns an Array list of found tokens   *
     *-------------------------------------------*/
    List getXMLTagArray(String sXMLContent, String sTag)
    {
      String       sLigne      = "" ;
      String       sXml        = "" ;
      String       sTagStart   = "<" + sTag + ">" ;
      String       sTagEnd     = "</" + sTag + ">" ;
      int          iIndex      = 0;
      int          iTagDeb     = 0 ;
      int          iTagEnd     = 0 ;
      int          iTagLength  = 0 ;
      int          iLigLength  = 0 ;      
      boolean      bCont       = true ;
      
      List liste = new ArrayList(5) ; 
      
      if( sXMLContent != null && sTag != null )
      {
        sXml = sXMLContent ;
        iTagLength = sTagStart.length() ;
        while(bCont)
        {
          iIndex++ ;
          iTagEnd = sXml.indexOf(sTagEnd) ;
          iTagDeb = sXml.indexOf(sTagStart) ;        
          iLigLength = (iTagEnd - ( iTagDeb + iTagLength ) ) ;
          if(iTagDeb > -1 && iTagEnd > -1 )
          {
             sLigne = sXml.substring(iTagDeb+iTagLength, iTagDeb+iTagLength+iLigLength);
             liste.add((Object)sLigne.trim());
             int i = iTagEnd + sTagEnd.length() ;
             if(i >=sXml.length()) bCont = false ;
             else sXml = sXml.substring(i);
          }
          else bCont = false ;
        }
      }
      return liste ;
    }
    
    /**----------------------------------*
     *    returns the content of a tag   *
     *-----------------------------------*/
    String getXMLTag(String sXMLContent, String sTag, String sNullValue)
    {
      String       sLigne      = null ;
      String       sXml        = "" ;
      String       sTagStart   = "<" + sTag + ">" ;
      String       sTagEnd     = "</" + sTag + ">" ;
      int          iTagDeb     = 0 ;
      int          iTagEnd     = 0 ;
      int          iTagLength  = 0 ;
      int          iLigLength  = 0 ;      
      
      if( sXMLContent != null && sTag != null )
      {
        sXml = sXMLContent ;
        iTagLength = sTagStart.length() ;
        iTagEnd = sXml.indexOf(sTagEnd) ;
        iTagDeb = sXml.indexOf(sTagStart) ;        
        iLigLength = (iTagEnd - ( iTagDeb + iTagLength ) ) ;
        if(iTagDeb > -1 && iTagEnd > -1 )
        {
           //log("deb="+iTagDeb+"  end="+iTagEnd+" len="+iLigLength);
           sLigne = sXml.substring(iTagDeb+iTagLength, iTagDeb+iTagLength+iLigLength);
           sLigne = sLigne.trim();
        }
      }
      if(sLigne != null && sLigne.equalsIgnoreCase("")) sLigne=null ;
      if((sLigne == null) && (sNullValue != null)) sLigne = sNullValue ;

      return sLigne ;
    }
    
    void readXMLMenu( String sTag ) {
        String st, st2 ;
        List l = getXMLTagArray(sXMLMenu, sTag) ;
        List lsub = null ;
        boolean b=true ;
        if(l.size()>0)
        {
            for( int j=0; j<l.size(); j++)
            {
                st = (String)l.get(j) ;
                // sub menus
                createMenu(1,st,"","");
            }
        }    
    }
    
    /*------------------*
     *  menu creation   *
     *------------------*/
    void createMenu( int iLevel, String sMenu, String sParent, String sChild ){
        String sLevel = "smenu" + iLevel ;
        String st = null, st2 = null ;
        String sLabel = getXMLTag(sMenu, "label", "null");
        log("Menu label: "+sLabel);
        JMenu jm = new JMenu(sLabel);
        jm.setBackground(this.getBackground());
        jm.setForeground(this.getForeground());
        jm.setFont(this.getFont());
        int iPos = 0 ;
        
        StringTokenizer stok = new StringTokenizer(sMenu,"|");

        while(stok.hasMoreTokens())
        {
          st = stok.nextToken().trim() ;
          log(" ->"+st);
          if(st.startsWith("<item>")){
              sLabel = getXMLTag(st, "item", "") ;
              addItem(sLabel, jm) ;
          }
          else if(st.startsWith("<smenu>")){
                iPos++;
                createSubMenu(st,jm);
          }          
        }        
        menu.add(jm);
    }
    
    /*------------------------*
     *  handle the sub menu   *
     *------------------------*/
    void createSubMenu(String s, JMenu jm) {
          String sLabel="", st=s, st2=null;
          boolean bCont = true ;
          JMenu   jmenu = null ;
          int    iPos = 0, iEnd = 0 ;
          int    z=0 ;
          log("---> createSubMenu(): "+st);            
          iPos = st.lastIndexOf("</smenu>");          
          if(iPos > -1) st = st.substring(7,iPos) ;
          while(st.trim().length() > 0){
              z++;
              log("---> suite:"+st);
              if(st.startsWith("<smenu>")) {
                log("  call recursive createSubMenu()");
                createSubMenu(st,jmenu);
                // remove sub menu part 
                iPos = st.lastIndexOf("<smenu>");
                iEnd = st.lastIndexOf("</smenu>");
                st = st.substring(0,iPos) + st.substring(iEnd + 8) ;
                log("   retour recursive createSubMenu():["+st+"]");
              }  
              else if(st.startsWith("<item>")){
                  sLabel = getXMLTag(st, "item", "") ;
                  log("Item:"+sLabel);
                  addItem(sLabel, jmenu) ;
                  iPos = st.indexOf("</item>") ;
                  //log("item:"+sLabel+ "    ipos:"+iPos);        
                  if(iPos > -1) st = st.substring(iPos+7);              
              }
              else if(st.startsWith("<label>")){
                  sLabel = getXMLTag(st, "label", "") ;
                  log("Label:"+sLabel);
                  jmenu = new JMenu(sLabel);
                  jm.add(jmenu);          
                  iPos = st.indexOf("</label>") ;
                  log("label:"+sLabel+ "    ipos:"+iPos);        
                  if(iPos > -1) st = st.substring(iPos+8);              
              }              
              log("   rest-->["+st+"]");              
              if((st.length() == 0) || (z > 10)) break ;
          }
          
    }
    
    /*--------------------*
     *   add a sub menu   *
     *--------------------*/
    void addSubMenu(String sLabel, JMenu jm){
        JMenu jmenu = new JMenu(sLabel);
        jm.add(jmenu);
    }
    
    /*---------------------------*
     *   add an item to a menu   *
     *---------------------------*/
    void addItem(String sLabel, JMenu jm){
        log("item found:"+sLabel);
        JMenuItem jmi = new JMenuItem(sLabel);
        jmi.setBackground(this.getBackground());
        jmi.setForeground(this.getForeground());
        jmi.setFont(this.getFont());
        jm.add(jmi);
    }
  
     public void log(String msg)
     {
       if(bLog) System.out.println("ComboMenuPJC(): " + msg);
     }
     
}
